using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using Infragistics.Win.Misc;



namespace MemoryLeakageCheck
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void button1_Click(object sender, EventArgs e)
        {
            Form2 f = new Form2();
            f.ShowDialog();
            DisposeControl(f);
            GC.Collect();
            

        }

        public static void DisposeControl(Control oControl)
        {
            if (oControl.GetType().ToString() == "Infragistics.Win.Misc.UltraPanel" ||
                oControl.GetType().ToString() == "TabletPCMain.TabletPCTitle1" ||
                oControl.GetType().ToString() == "TabletPCMain.TabletPCTitle2" ||
                oControl.GetType().ToString() == "TabletPCMain.TabletPCSectionPanel")
            {
                UltraPanel panel = ((Infragistics.Win.Misc.UltraPanel)oControl);

                while (panel.ClientArea.Controls.Count > 0)
                {

                    if (panel.ClientArea.Controls[0].HasChildren)
                    {
                        DisposeControl(panel.ClientArea.Controls[0]);
                    }
                    else
                    {
                        if (panel.ClientArea.Controls[0].GetType().ToString() == "Infragistics.Win.Misc.UltraPanel" ||
                            panel.ClientArea.Controls[0].GetType().ToString() == "TabletPCMain.TabletPCTitle1" ||
                            panel.ClientArea.Controls[0].GetType().ToString() == "TabletPCMain.TabletPCTitle2" ||
                            panel.ClientArea.Controls[0].GetType().ToString() == "TabletPCMain.TabletPCSectionPanel")
                        {
                            DisposeControl(panel.ClientArea.Controls[0]);
                        }
                        else
                        {
                            panel.ClientArea.Controls[0].Dispose();
                        }
                    }
                }
                panel.Dispose();
            }
            else
            {
                while (oControl.Controls.Count > 0)
                {
                    if (oControl.Controls[0].HasChildren)
                    {
                        DisposeControl(oControl.Controls[0]);
                    }
                    else
                    {
                        oControl.Controls[0].Dispose();
                    }
                }
                oControl.Dispose();
            }
        }
    }
}